
import "Turbine.UI";
import "Turbine.UI.Extensions";
import "Turbine.Utils";

DraggableWindow = class( Turbine.UI.Extensions.SimpleWindow );

function DraggableWindow:Constructor(hotspotSize)
	Turbine.UI.Extensions.SimpleWindow.Constructor( self );

	self.MouseDown = function( sender, args )
		self._dragStartX = args.X;
		self._dragStartY = args.Y;
		self._dragging = true;
	end

	self.MouseMove = function( sender, args )
		if ( self._dragging ) then
			local left, top = self:GetPosition();
			self:SetPosition(left + ( args.X - self._dragStartX ), top + ( args.Y - self._dragStartY ) );
		end
	end

	self.MouseUp = function( sender, args )
		self._dragging = false;
	end
end