import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.Animation";
import "Deusdictum.UI.DragBar";

function loadSettings()
cjhSettings=Turbine.PluginData.Load( Turbine.DataScope.Character, "CJHelper" );
if ( type( cjhSettings ) ~= "table" ) then
		cjhSettings = {bXset=800,bYset=20};
	end
	if (cjhSettings.bXset == nil)then
		cjhSettings.bXset=800;
	end
	if (cjhSettings.bYset == nil)then
		cjhSettings.bYset=20;
	end
	return cjhSettings;
end

function saveSettings(bXcoord,bYcoord)
	cjhSettings.bXset=bXcoord;
	cjhSettings.bYset=bYcoord;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "CJHelper", cjhSettings );
end

player = Turbine.Gameplay.LocalPlayer();

cjhSettings = loadSettings();
local bXset = cjhSettings.bXset;
local bYset = cjhSettings.bYset;

cjNum = 1;
cjCol = 1;
cjColour = Turbine.UI.Color( 1, 0, 0, 1 );
cjWhite = Turbine.UI.Color( 1,1,1 );
cjBlack = Turbine.UI.Color( 0,0,0 );
cjHide = 1.0;
setMV = true;

cjButton = Turbine.UI.Window();
cjButton:SetParent(QuestTracker);
cjButton:SetOpacity(cjHide);
cjButton:SetMouseVisible (true);
cjButton:SetBackColor( Turbine.UI.Color( 1, 1, 1, 1 ));
cjButton:SetBlendMode(0);
cjButton:SetVisible(setMV);
cjButton:SetWantsUpdates(true);
cjButton:SetPosition( bXset , bYset );
cjButton:SetSize( 30 , 30 );
cjButton.DragBar = Deusdictum.UI.DragBar( cjButton, "CJ Helper" );

cjText = Turbine.UI.Label();
cjText:SetParent( cjButton );
cjText:SetSize( 28 , 28 );
cjText:SetBackColor( cjColour );
cjText:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
cjText:SetPosition( 1 , 1 );
cjText:SetFont( Turbine.UI.Lotro.Font.Verdana22 );
cjText:SetText( cjNum );
cjText:SetMouseVisible (setMV);
cjText:SetForeColor( cjWhite ) 

function cjText:MouseClick( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
		if ( not self.dragging ) then
			if ( cjNum < 6 ) then
				cjNum = (cjNum + 1);
			else
				cjNum = 1;
			end
			cjText:SetText( cjNum );
			bX, bY = cjButton:GetPosition();
			saveSettings( bX, bY );
		end
	end
	
	if ( args.Button == Turbine.UI.MouseButton.Right ) then
			if ( cjCol < 4 ) then
				cjCol = (cjCol + 1);
			else
				cjCol = 1;
			end
			if (cjCol < 2 ) then
				cjText:SetForeColor(cjWhite);
			else
				cjText:SetForeColor(cjBlack);
			end
			if (cjCol == 1 ) then
				cjColour = Turbine.UI.Color( 1, 0, 0, 1 ); --blue
			end
			if (cjCol == 2 ) then
				cjColour = Turbine.UI.Color( 1, 0, 1, 0 ); --red
			end
			if (cjCol == 3 ) then
				cjColour = Turbine.UI.Color( 1, 1, 0, 0 ); --green
			end
			if (cjCol == 4 ) then
				cjColour = Turbine.UI.Color( 1, 1 , 1 , 0 ); --yellow
			end
			cjText:SetBackColor(cjColour);
	end
end

function player:InCombatChanged(sender, args)
	if (player:IsInCombat() ) then
		cjHide = 1.0;
		setMV = false;
		else
		cjHide = 0.0;
		setMV = true;
	end
	cjButton:SetOpacity(cjHide);
	cjButton:SetMouseVisible(setMV);
	cjText:SetMouseVisible(setMV);
end

cjButton.MouseEnter = function(sender, args)
	cjHide = 1.0;
	cjButton:SetOpacity(cjHide);
end

cjButton.MouseLeave = function(sender, args)
	if (not player:IsInCombat() ) then
		cjHide = 0.0;
	end
	cjButton:SetOpacity(cjHide);
end